pub mod declaration;
pub mod element;
mod endable;
mod error;
pub mod reader;
mod writer;
pub mod xml;

pub type Result<T> = std::result::Result<T, error::Error>;

pub const XML_NS: &str = "http://www.w3.org/XML/1998/namespace";
pub const XMLNS_NS: &str = "http://www.w3.org/2000/xmlns/";

pub use element::Element;
pub use error::DeserializeError;
pub use error::Error;
pub use reader::Reader;
pub use writer::Writer;
